<?php

abstract class AbstractRestController extends ModuleFrontController
{
    public function init()
    {
        header('Content-Type: ' . "application/json");
        
        parent::init();
        
        $response = [
            'success' => true,
            'code' => 210,
            'psdata' => null,
            'message' => 'empty'
        ];

        switch ($_SERVER['REQUEST_METHOD']) {
            case 'GET':
                $response = $this->processGetRequest();
                break;
            case 'POST':
                $response = $this->processPostRequest();
                break;
            case 'PATCH':
            case 'PUT':
                $response = $this->processPutRequest();
                break;
            case 'DELETE':
                $response = $this->processDeleteRequest();
                break;
            default:
                // throw some error or whatever
        }
        $this->ajaxRender(json_encode($response));
        die;
    }
    
    abstract protected function processPostRequest();
}
